; MP3 Stream Server

on *:sockread:init*: {
  sockread -fn %sw.dump
  tokenize 32 %sw.dump
  if (%scrlogall == on) { scrnlog $+(ID:[,$remove($sockname,stream),]) $+(IP:[,$sock($sockname).ip,]) $+(Data:[,$1-,]) }
  if ($1 == GET) { set %sw.file $+($readini(streamworks,server,dir),$replace($right($remove($2-,HTTP/1.0,HTTP/1.1),-1),/,\,$+($chr(37),20),$chr(32))) }
  if ($left($1-,11) == User-Agent:) { set %sw.agent $iif($left($right($1-,-11),1) == $chr(32),$right($1-,-12),$right($1-,-11)) }
  if ($1 == Range:) { set %sw.startfrom $left($remove($2,bytes=),-1) }
  if ($left($1-,5) == Host: && $readini(streamworks,server,bindip) != $null) { if ($readini(streamworks,server,bindip) !isin $right($1-,-5)) { sockclose $sockname } }
  if ($left($1-,13) == Icy-MetaData: && $readini(streamworks,server,metadata) == on) { if (1 isin $right($1-,-13)) { set %sw.meta metadata } }
  if ($1 == $null) {
    if ($banip($sock($sockname).ip) == banned) { sockwrite -n $sockname HTTP/1.1 405 NOT ALLOWED | sockclose $sockname | halt }
    sockmark $sockname $+(%sw.file,$chr(1),%sw.agent,$chr(1),$iif(%sw.startfrom,%sw.startfrom,1),$chr(1),%sw.meta)
    unset %sw.startfrom
    unset %sw.meta
    if ((Mozilla isin %sw.agent && %scrlogall == on) || Mozilla !isin %sw.agent) scrnlog Connection accepted: $sock($sockname).ip (ID: $remove($sockname,init) $+ ) (Agent: %sw.agent $+ )
    startstream $sockname
  }
}

alias -l scrnlog {
  if (!$window(@Streamworks) && %scrlog == on) { window -ek0 @Streamworks }
  if ($window(@Streamworks) && %scrlog == on) { echo @Streamworks $+([,$date,$chr(32),$time,]) $1- }
}

alias -l banip {
  if ($isid && $1) {
    if ($readini(banip.ini,bans,$1) == banned) { return banned }
    if ($readini(banip.ini,bans,$1) != banned) { return allow }
  }
}

alias shoutcastyp {
  if (!$sock(listyp) && $sock(servstreamworks)) {
    sockopen listyp yp.shoutcast.com 80
    scrnlog [YP ADD] Contacting yp.shoutcast.com:80
  }
}

on *:sockopen:listyp: {
  if ($sock(servstreamworks)) {
    set %lyp.br $iif($readini(streamworks,server,kbps),$readini(streamworks,server,kbps),320)
    set %lyp.p $iif($sock(servstreamworks).port,$sock(servstreamworks).port,$readini(streamworks,server,port))
    set %lyp.m $iif($readini(streamworks,server,maxlive),$readini(streamworks,server,maxlive),3)
    set %lyp.t $iif($readini(streamworks,server,scname),$replace($readini(streamworks,server,scname),$chr(32),$+($chr(37),20)),$+($iif($nick,$+($nick,'s,$chr(37),20,StreamWorks),StreamWorks),$chr(37),20,Server))
    set %lyp.g $iif($readini(streamworks,server,scgenre),$replace($readini(streamworks,server,scgenre),$chr(32),$+($chr(37),20)),$+(Local,$chr(37),20,MP3s))
    set %lyp.url $iif($readini(streamworks,server,scurl),$readini(streamworks,server,scurl),$+(http://,$swip,:,%scyp.port,/))
    set %lyp.get $+(/addsrv?v=1&br=,%lyp.br,&p=,%lyp.p,&m=,%lyp.m,&t=,%lyp.t,&g=,%lyp.g,&url=,%lyp.url,&content=audio/mpeg&irc=&icq=&aim=)
    sockwrite -n listyp GET %lyp.get HTTP/1.0
    sockwrite -n listyp Host: yp.shoutcast.com
    sockwrite -n listyp Accept: */*
    sockwrite -n listyp $crlf
    unset %lyp.*
    scrnlog [YP ADD] Adding server to list...
  }
}

on *:sockread:listyp: {
  sockread -fn %lyp.dump
  tokenize 32 %lyp.dump
  ;SHOUTcast Directory Listing
  if ($1 == icy-response: && $2 == ack) { scrnlog [YP ADD] Success: yp.shoutcast.com added me! | tchscyp }
  if ($1 == icy-error: && $2 != $null) { scrnlog [YP ADD] ERROR: $2- }
  if ($1 == icy-id: && $2 isnum) { set %sw.ypid $2 }
  if ($1 == icy-tchfrq: && $2 isnum) { .timertchscyp 0 $calc($2 * 60) tchscyp | set %sw.yptch $2 }
}

alias tchscyp {
  if (!$sock(tchyp) && $sock(servstreamworks)) { sockopen tchyp yp.shoutcast.com 80 }
}

on *:sockopen:tchyp: {
  if ($sock(servstreamworks)) {
    set %tchyp.p $iif($sock(servstreamworks).port,$sock(servstreamworks).port,$readini(streamworks,server,port))
    set %tchyp.li $sock(livestream*,0)
    ;set %tchyp.rand $rand(1,$findfile($readini(streamworks,server,dir),*.mp3,0,0))
    ;set %tchyp.mp3 $findfile($readini(streamworks,server,dir),*.mp3,%tchyp.rand)
    ;set %tchyp.ct $replace($sound(%tchyp.mp3).artist - $sound(%tchyp.mp3).title,$chr(32),$+($chr(37),20),`,')
    set %tchyp.ct $replace(A New Random Track On Every Connection!,$chr(32),$+($chr(37),20))
    set %tchyp.get $+(/tchsrv?id=,%sw.ypid,&p=,%tchyp.p,&li=,%tchyp.li,&alt=0&ct=,%tchyp.ct,&cm=0&ht=0)
    sockwrite -n $sockname GET %tchyp.get HTTP/1.0
    sockwrite -n $sockname Host: yp.shoutcast.com
    sockwrite -n $sockname Accept: */*
    sockwrite -n $sockname $crlf
    unset %tchyp.*
  }
  if (!$sock(servstreamworks)) { rmvscyp }
}

on *:sockread:tchyp: {
  sockread -fn %tchyp.dump
  tokenize 32 %tchyp.dump
  if ($1 == icy-tchfrq: && $2 isnum && $2 != %sw.yptch) {
    .timertchscyp 0 $calc($2 * 60) tchscyp
    set %sw.yptch $2
  }
  if ($1 == icy-response: && $2 == ack) { scrnlog [YP TCH] Success: yp.shoutcast.com touched! }
  if ($1 == icy-error: && $2 != $null) { scrnlog [YP TCH] ERROR: $2- }
}

alias rmvscyp {
  if (!$sock(rmvyp) && %sw.ypid) {
    sockopen rmvyp yp.shoutcast.com 80
    .timertchscyp off
  }
}

on *:sockopen:rmvyp: {
  if (%sw.ypid) {
    set %rmvyp.p $iif($sock(servstreamworks).port,$sock(servstreamworks).port,$readini(streamworks,server,port))
    sockwrite -n $sockname GET $+(/remsrv?id=,%sw.ypid,&p=,%rmvyp.p) HTTP/1.0
    sockwrite -n $sockname Host: yp.shoutcast.com
    sockwrite -n $sockname Accept: */*
    sockwrite -n $sockname $crlf
    unset %rmvyp.*
    scrnlog [YP RMV] Removing server from list...
  }
}

on *:sockread:rmvyp: {
  sockread -fn %rmvyp.dump
  tokenize 32 %rmvyp.dump
  if ($1 == icy-response: && $2 == ack) { scrnlog [YP RMV] Success: yp.shoutcast.com removed me! }
  if ($1 == icy-error: && $2 != $null) { scrnlog [YP RMV] ERROR: $2- }
}

alias -l scanartists {
  .remove artists.ini
  set %sw.dir $iif($readini(streamworks,server,dir),$readini(streamworks,server,dir),C:\)
  unset %sw.number
  unset %sw.letter
  unset %scanned
  set %scanned 1
  set %sw.number 0
  unset %sw.lastnumber
  set %sw.files $findfile(%sw.dir,0*.mp3,0,$readini(streamworks,server,alldir))
  :rescan.numbers
  while (%scanned <= %sw.files && %sw.number <= 9) {
    set %the.file $findfile(%sw.dir,$+(%sw.number,*.mp3),%scanned,$readini(streamworks,server,alldir))
    set %the.artist $nopath($left(%the.file,$calc($pos(%the.file,-,1) - 1)))
    writeini artists.ini %sw.number $replace(%the.artist,$chr(32),$chr(160)) list
    inc %scanned
  }
  goto check.left
  :scan.letters
  set %sw.letter 65
  set %sw.lastletter 0
  set %sw.files $findfile(%sw.dir,A*.mp3,0,$readini(streamworks,server,alldir))
  :rescan.letters
  while (%scanned <= %sw.files && %sw.letter <= 90 && %sw.letter >= 65) {
    set %the.file $findfile(%sw.dir,$+($chr(%sw.letter),*.mp3),%scanned,$readini(streamworks,server,alldir))
    set %the.artist $nopath($left(%the.file,$calc($pos(%the.file,-,1) - 1)))
    writeini artists.ini $chr(%sw.letter) $replace(%the.artist,$chr(32),$chr(160)) list
    inc %scanned
  }
  :check.left
  if (%scanned > %sw.files) {
    unset %artists
    if (%sw.number == 9) {
      inc %sw.letter
      set %sw.files $findfile(%sw.dir,$+($chr(%sw.letter),*.mp3),0,$readini(streamworks,server,alldir))
      set %scanned 1
      if (%sw.letter == 1) { goto scan.letters }
      if (%sw.letter >= 66) { goto rescan.letters }
    }
    if (%sw.number <= 8) {
      inc %sw.number
      set %sw.files $findfile(%sw.dir,$+(%sw.number,*.mp3),0,$readini(streamworks,server,alldir))
      set %scanned 1
      goto rescan.numbers
    }
  }
  unset %scanned
  unset %the.*
}

alias startstream {
  set %sw.sockname $1
  tokenize 1 $sock($1).mark
  set %sw.dir $iif($readini(streamworks,server,dir),$readini(streamworks,server,dir),C:\)
  unset %sw.request
  set %sw.request $remove($1,%sw.dir)
  set %sw.server $+(http://,$swip,:,$sock(servstreamworks).port,/)
  if (Mozilla isin $2) {
    if ($left(%sw.request,8) == playall\ && $right(%sw.request,4) == .m3u) {
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Content-Type: audio/mpegurl
      sockwrite -n %sw.sockname Connection: Close
      sockwrite -n %sw.sockname $crlf
      sockwrite -n %sw.sockname #EXTM3U
      set %dump $findfile(%sw.dir,$+($remove(%sw.request,playall\,.m3u),*.mp3),0,sockwrite -n %sw.sockname $+(#EXTINF:,$int($calc($sound($1-).length / 1000)),$chr(44),$sound($1-).artist - $sound($1-).title,$chr(32),[mIRC Streamworks Server]) $crlf $replace($1-,%sw.dir,%sw.server,\,/))
      sockclose %sw.sockname
      unset %dump
      halt
    }
    if ($right(%sw.request,4) == .m3u && $exists($replace($1,.m3u,.mp3)) == $true) {
      set %sw.actualfile $replace($1,.m3u,.mp3)
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Content-Type: audio/mpegurl
      sockwrite -n %sw.sockname Connection: close
      sockwrite -n %sw.sockname $crlf
      sockwrite -n %sw.sockname #EXTM3U
      sockwrite -n %sw.sockname $+(#EXTINF:,$int($calc($sound(%sw.actualfile).length / 1000)),$chr(44),$sound(%sw.actualfile).artist - $sound(%sw.actualfile).title,$chr(32),[mIRC Streamworks Server])
      sockwrite -n %sw.sockname $replace(%sw.actualfile,%sw.dir,%sw.server,\,/)
      sockclose %sw.sockname
      halt
    }
    if (%sw.request == listen.pls && $readini(streamworks,server,livemode) == on) {
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Content-Type: audio/x-scpls
      sockwrite -n %sw.sockname Content-Disposition: filename=listen.pls
      sockwrite -n %sw.sockname Connection: close
      sockwrite -n %sw.sockname $crlf
      sockwrite -n %sw.sockname [Playlist]
      sockwrite -n %sw.sockname File1= $+ %sw.server
      sockwrite -n %sw.sockname Title1=Live Streaming $iif($readini(streamworks,server,mystream) == on,$+([http://,%sw.server,mystream,])) [mIRC Streamworks Server]
      sockwrite -n %sw.sockname Length1=-1
      sockwrite -n %sw.sockname Numberofentries=1
      sockwrite -n %sw.sockname Version=2
    }
    ; PAGES
    sockwrite -n %sw.sockname HTTP/1.1 200 OK
    sockwrite -n %sw.sockname $crlf
    sockwrite -n %sw.sockname <html><title>Cynagen's mIRC Streamworks Server</title><body><center>
    set %sw.files $findfile(%sw.dir,*.mp3,0)
    if (%sw.request == $null) {
      sockwrite -n %sw.sockname <h4>List of Artists on this server:</h4><br>
      unset %sw.sections
      unset %sw.artists
      unset %sw.lastsection
      unset %scanned.sections
      unset %scanned.artists
      set %scanned.sections 1
      set %scanned.artists 1
      set %sw.sections $ini(artists.ini,0)
      while (%scanned.sections <= %sw.sections) {
        if (%scanned.sections != %sw.lastsection) {
          sockwrite -n %sw.sockname $+(<br><b>,$ini(artists.ini,%scanned.sections),</b>,<br>)
          set %sw.lastsection %scanned.section
          set %sw.artists $ini(artists.ini,%scanned.sections,0)
        }
        while (%scanned.artists <= %sw.artists) {
          set %the.artist $replace($ini(artists.ini,%scanned.sections,%scanned.artists),$chr(160),$chr(32))
          sockwrite -n %sw.sockname $+(<a href=",%sw.server,artist/,%the.artist,">,%the.artist,</a><br>)
          inc %artistcount
          inc %scanned.artists
        }
        inc %scanned.sections
        set %scanned.artists 1
      }
      unset %scanned.*
      unset %the.*
      sockwrite -n %sw.sockname <br>Total of $+(<b>,%artistcount,</b>) Artists
      unset %artistcount
    }
    if ($left(%sw.request,7) == artist\) {
      set %sw.artist $right(%sw.request,-7)
      sockwrite -n %sw.sockname <h4>List of songs by: %sw.artist $+ </h4>
      sockwrite -n %sw.sockname <table width=500 border=0 cellspacing=0 cellpadding=0>
      sockwrite -n %sw.sockname <tr><td width=300 align=center>Title:</td><td width=50 align=center bgcolor=cccccc>Bitrate:</td><td width=100 align=center>Length:</td><td width=50 align=center bgcolor=cccccc>Size:</td></tr>
      set %sw.found $findfile(%sw.dir,$+(%sw.artist,*.mp3),0,sockwrite -n %sw.sockname $+(<tr><td width=300 align=center><a href=",$replace($1-,%sw.dir,%sw.server,.mp3,.m3u),">,$sound($1-).title,</a></td><td width=50 align=center bgcolor=cccccc>,$sound($1-).bitrate,kbps,</td><td width=100 align=center>,$duration($calc($sound($1-).length / 1000)),</td><td width=50 align=center bgcolor=cccccc>,$bytes($file($1-).size,m3).suf,</td></tr>))
      sockwrite -n %sw.sockname </table><br>
      if (%sw.found >= 5) { sockwrite -n %sw.sockname $+(<a href=",%sw.server,playall/,%sw.artist,.m3u,">Play all songs from %sw.artist,</a><br>) }
      sockwrite -n %sw.sockname Found %sw.found songs
    }
    if (%sw.request == help\support) {
      sockwrite -n %sw.sockname <h2>Help: Support</h2><hr>
      sockwrite -n %sw.sockname Support for this mIRC addon can be found in the simple help system provided here, or on the web at <a href="http://www.cynagen.com/" target="_blank">Cynagen Scripting</a><p>
      sockwrite -n %sw.sockname Here is a list of provided help built into the addon:<br>
      sockwrite -n %sw.sockname FAQ<br>
      sockwrite -n %sw.sockname Players supported<br>
    }
    if (%sw.request == help\faq) {
      sockwrite -n %sw.sockname <h2>Help: FAQ</h2><hr>
      sockwrite -n %sw.sockname Q: Sharing MP3s is "illegal", is this addon illegal?<br>
      sockwrite -n %sw.sockname A: Nope. This addon isn't illegal... but sharing MP3s over the net with it is.<p>
      sockwrite -n %sw.sockname Q: Can you download the entire songs from this server?<br>
      sockwrite -n %sw.sockname A: No you cannot... I've designed the addon to disable downloading of any kind aside from streaming.<p>
      sockwrite -n %sw.sockname Q: I have a question but the internal help doesn't have an answer... Where can I get help?<br>
      sockwrite -n %sw.sockname A: Go ahead and e-mail <a href="mailto:streamworks@cynagen.com?subject=Help">Streamworks Help</a> with your question.<p>
    }
    if (%sw.request == help\players) {
      sockwrite -n %sw.sockname <h2>Help: Supported Players</h2><hr>
      sockwrite -n %sw.sockname As of this version of Streamworks, this is the list of supported players.<p>
      sockwrite -n %sw.sockname Windows:<br>
      sockwrite -n %sw.sockname <a href="http://classic.winamp.com/" target="win">Winamp 2.xx</a><br>
      sockwrite -n %sw.sockname <a href="http://www.winamp.com/" target="win">Winamp 3</a><br>
      sockwrite -n %sw.sockname <a href="http://www.real.com/R/RC.060203r1cp_home_dl.bodymain.img..R/forms.real.com/real/realone/realone.html?dc=969594&type=dl&beta_bypass=true&bbits=true&src=082503realhome_1_3_2,060203r1cp_home_dl" target="win">RealPlayer/RealOne</a><p>
      sockwrite -n %sw.sockname (Apple) Macintosh:<br>
      sockwrite -n %sw.sockname <a href="http://www.apple.com/itunes" target="mac">iTunes</a><br>
      sockwrite -n %sw.sockname <a href="http://www.panic.com/audion" target="mac">Audion</a><br>
      sockwrite -n %sw.sockname <a href="https://order.real.com/pt/order.html?ppath=cpromac040702a&language=EN&country=US&type=macbeta&src=082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2,082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2,021017r1mac_1" target="mac">RealOne for MAC OS X</a><br>
      sockwrite -n %sw.sockname <a href="http://www.real.com/R/RC.082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2,021017r1mac_1.ecomm.txt..R/forms.real.com/real/player/blackjack.html?dc=969594&lang=&loc=&src=082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2,082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2,021017r1mac_1" target="mac">RealOne for MAC OS 8 & MAC OS 9.x</a><p>
      sockwrite -n %sw.sockname Unix/Linux:<br>
      sockwrite -n %sw.sockname <a href="http://forms.real.com/real/player/unix/unix.html?src=082503realhome_1_3_2,060203r1cp_home_dl,082503realhome_1_3_2" target="lin">User Supported RealOne for Unix/Linux builds</a><p>
      sockwrite -n %sw.sockname I will be adding support for more players as people bring them to my attention.<br>
      sockwrite -n %sw.sockname Also, I can only test support for Windows based players by myself...<br>
      sockwrite -n %sw.sockname If there is somebody out there with a Linux/Unix machine or an (Apple) Macintosh, with programs not already listed, that would like to help test... please e-mail <a href="mailto:streamworks@cynagen.com?subject=Tester">Streamworks Help</a><br>
    }
    if (%sw.request == disclaimer) {
      sockwrite -n %sw.sockname <h2>Disclaimer</h2><hr>
      sockwrite -n %sw.sockname Admin: By running this addon, you are absolving Cynagen & Cynagen Scripting from any legal reprocussions that may or may not occur from running this addon.<p>
      sockwrite -n %sw.sockname Users: By using this addon, you absolve Cynagen & Cynagen Scripting from any legal reprocussions that may or may not occur from using this addon.<p>
      sockwrite -n %sw.sockname Laymen's Terms: You run this addon or use it to listen to other's tunes... That's your business... not mine. You get sued, don't come bitching to me.<p>
    }
    if ($left(%sw.request,9) == mystream\ && $readini(streamworks,server,mystream) == on) {
      set %streamname $right(%sw.request,-9)
      set %ip $sock(%sw.sockname).ip
      set %streamip $sock(%streamname).ip
      if ($sock(%streamname) != $null) {
        if (%streamip == %ip) {
          tokenize 1 $sock(%streamname).mark
          sockwrite -n %sw.sockname <h2>Your Stream:</h2>
          sockwrite -n %sw.sockname <table width=500 border=0 cellpadding=0 cellspacing=0>
          sockwrite -n %sw.sockname <tr><td width=150 bgcolor=cccccc>Artist:<td width=350 bgcolor=cccccc> $+ $sound($1).artist $+ </td></tr>
          sockwrite -n %sw.sockname <tr><td width=150>Title:<td width=350> $+ $sound($1).title $+ </td></tr>
          sockwrite -n %sw.sockname <tr><td width=150 bgcolor=cccccc>Album:<td width=350 bgcolor=cccccc> $+ $sound($1).album $+ </td></tr>
          sockwrite -n %sw.sockname <tr><td width=150>Length:<td width=350> $+ $duration($calc($sound($1).length / 1000)) $+ </td></tr>
          sockwrite -n %sw.sockname <tr><td width=150 bgcolor=cccccc>Bandwidth:<td width=350 bgcolor=cccccc> $+ $sound($1).bitrate $+ kbps</td></tr>
          sockwrite -n %sw.sockname <tr><td width=150>Total Sent:<td width=350> $+ $calc(100 - $int($calc((($3 - $2) / $3) * 100))) $+ $chr(37) $+ </td></tr>
          sockwrite -n %sw.sockname <tr><td width=150 bgcolor=cccccc>Player:<td width=350 bgcolor=cccccc> $+ $4 $+ </td></tr>
          sockwrite -n %sw.sockname </table>
          sockwrite -n %sw.sockname <meta http-equiv="refresh" $+(content="5;url=,%sw.server,mystream/,%streamname,">)
        }
        if (%streamip != %ip) {
          sockwrite -n %sw.sockname <h1>THIS IS NOT ONE OF YOUR STREAMS</h1>
        }
      }
      if ($sock(%streamname) == $null && $readini(streamworks,server,mystream) == on) {
        sockwrite -n %sw.sockname <h1>STREAM DOES NOT EXIST!</h1>
      }
    }
    if (%sw.request == mystream) {
      set %stream 1
      set %matches 0
      set %ip $sock(%sw.sockname).ip
      while (%stream <= $sock(livestream*,0)) {
        if ($sock(livestream*,%stream).ip == %ip) { inc %matches }
        inc %stream
      }
      unset %stream
      if (%matches == 0) {
        sockwrite -n %sw.sockname <h2>Your Stream:</h2>
        sockwrite -n %sw.sockname You have no current LIVE streams.
      }
      if (%matches == 1) {
        set %stream 1
        while (%stream <= $sock(livestream*,0)) {
          if ($sock(livestream*,%stream).ip == %ip) {
            sockwrite -n %sw.sockname <meta http-equiv="refresh" content="0;url= $+ %sw.server $+ mystream/ $+ $sock(livestream*,%stream) $+ ">
            goto exitscan
          }
          inc %stream
        }
        :exitscan
        unset %stream
      }
      if (%matches >= 2) {
        set %stream 1
        while (%stream <= $sock(livestream*,0)) {
          if ($sock(livestream*,%stream).ip == %ip) {
            sockwrite -n %sw.sockname $+(<a href=",%sw.server,mystream/,$sock(livestream*,%stream),">,$sock(livestream*,%stream),</a><br>)
          }
          inc %stream
        }
        unset %stream
      }
    }
    if ($left(%sw.request,4) == help || %sw.request == disclaimer || $left(%sw.request,8) == mystream || $left(%sw.request,6) == artist) { sockwrite -n %sw.sockname $+(<br><a href=",%sw.server,">Main</a><br>) }
    if ($readini(streamworks,server,livemode) == on) { sockwrite -n %sw.sockname <br><a href=" $+ %sw.server $+ listen.pls">Listen to a Live stream!</a> }
    sockwrite -n %sw.sockname <br>Help: <a href=" $+ %sw.server $+ help\support">Support</a> $chr(124) <a href=" $+ %sw.server $+ help\faq">FAQ</a> $chr(124) <a href=" $+ %sw.server $+ help\players">Supported Players</a><br>
    sockwrite -n %sw.sockname Copyright 2003 Cynagen & <a href="http://www.cynagen.com/" target="_blank">Cynagen Scripting</a> $chr(124) <a href="/disclaimer">Disclaimer</a>
    sockwrite -n %sw.sockname </center></body></html>
    sockwrite -n %sw.sockname $crlf
    sockclose %sw.sockname
    halt
  }
  if ($whatis($2) == player) {
    sockrename %sw.sockname $replace(%sw.sockname,init,stream)
    set %sw.sockname $replace(%sw.sockname,init,stream)
    set %sw.streamfile $replace($1,$+($chr(37),20),$chr(32),$+($chr(37),27),$chr(39))
    if ($whatis($2).init == advanced) {
      if ($right(%sw.streamfile,4) == .m3u && $exists($replace(%sw.streamfile,.m3u,.mp3)) == $true) {
        if ($sock(stream*,0) > $readini(streamworks,server,maxsingle)) {
          sockwrite -n %sw.sockname ICY 504 Server Full
          sockclose %sw.sockname
          halt
        } 
        set %sw.actualfile $replace(%sw.streamfile,.m3u,.mp3)
        set %sw.filesize $file(%sw.actualfile).size
        sockmark %sw.sockname $+(%sw.actualfile,$chr(1),$3,$chr(1),%sw.filesize,$chr(1),$2,$chr(1),$4)
        sockwrite -n %sw.sockname HTTP/1.1 200 OK
        sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
        sockwrite -n %sw.sockname Connection: close
        sockwrite -n %sw.sockname Accept-Ranges: bytes
        sockwrite -n %sw.sockname Content-Length: %sw.filesize
        sockwrite -n %sw.sockname Content-Range: $+(0-,$calc(%sw.filesize - 1),/,%sw.filesize)
        sockwrite -n %sw.sockname Content-Type: audio/mpeg
        sockwrite -n %sw.sockname $crlf
        sockwrite -n %sw.sockname $+(icy-name:,$sound(%sw.actualfile).artist - $sound(%sw.actualfile).title,$chr(32),[mIRC Streamworks Server]) 
        sockwrite -n %sw.sockname $+(icy-br:,$sound(%sw.actualfile).bitrate)
        streamit %sw.sockname
        listthestreams
      }
      if ($right(%sw.streamfile,4) == .mp3 && $exists(%sw.streamfile) == $true) {
        if ($sock(stream*,0) > $readini(streamworks,server,maxsingle)) {
          sockwrite -n %sw.sockname ICY 504 Server Full
          sockclose %sw.sockname
          halt
        } 
        set %sw.filesize $file(%sw.streamfile).size
        sockmark %sw.sockname $+(%sw.actualfile,$chr(1),$3,$chr(1),%sw.filesize,$chr(1),$2,$chr(1),$4)
        sockwrite -n %sw.sockname HTTP/1.1 200 OK
        sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
        sockwrite -n %sw.sockname Accept-Ranges: bytes
        sockwrite -n %sw.sockname Content-Length: %sw.filesize
        sockwrite -n %sw.sockname Content-Range: $+(0-,$calc(%sw.filesize - 1),/,%sw.filesize)
        sockwrite -n %sw.sockname Content-Type: audio/mpeg
        sockwrite -n %sw.sockname $+(icy-name:,$sound(%sw.streamfile).artist - $sound(%sw.streamfile).title,$chr(32),[mIRC Streamworks Server]) 
        sockwrite -n %sw.sockname $+(icy-br:,$sound(%sw.streamfile).bitrate)
        sockwrite -n %sw.sockname Connection: close
        sockwrite -n %sw.sockname $crlf
        streamit %sw.sockname
        listthestreams
      }
      if ((%sw.request == $null || %sw.request == listen.pls) && $readini(streamworks,server,livemode) == on) { 
        if ($sock(livestream*,0) >= $readini(streamworks,server,maxlive)) {
          sockwrite -n %sw.sockname ICY 504 Server Full
          sockclose %sw.sockname
          halt
        } 
        :pickrand
        set %randnum $rand(1,$findfile($readini(streamworks,server,dir),*.mp3,0,$readini(streamworks,server,alldir)))
        set %sw.track $findfile($readini(streamworks,server,dir),*.mp3,%randnum,$readini(streamworks,server,alldir))
        if ($sound(%sw.track).sample != 44100 || Stereo !isin $sound(%sw.track).mode) { goto pickrand }
        if ($readini(streamworks,server,restrict) == on && $sound(%sw.track).bitrate > $readini(streamworks,server,kbps)) { goto pickrand }
        set %size $file(%sw.track).size
        sockmark %sw.sockname $+(%sw.track,$chr(1),1,$chr(1),%size,$chr(1),$2,$chr(1),$4)
        sockwrite -n %sw.sockname HTTP/1.1 200 OK
        sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
        sockwrite -n %sw.sockname Connection: Keep-Alive
        sockwrite -n %sw.sockname Content-Length: 0
        sockwrite -n %sw.sockname Content-Type: audio/mpeg
        sockwrite -n %sw.sockname icy-name: Live Streaming $iif($readini(streamworks,server,mystream) == on,$+([http://,%sw.server,mystream,])) [mIRC Streamworks Server]
        if ($4 == metadata) { sockwrite -n %sw.sockname icy-metaint: 4096 }
        sockwrite -n %sw.sockname $crlf
        sockrename %sw.sockname $+(live,%sw.sockname)
        livestream $+(live,%sw.sockname)
        listthestreams
      }
      halt
    }
    if ($left(%sw.request,8) == playall\ && $right(%sw.request,4) == .m3u) {
      if ($sock(stream*,0) > $readini(streamworks,server,maxsingle)) {
        sockwrite -n %sw.sockname ICY 504 Server Full
        sockclose %sw.sockname
        halt
      } 
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Content-Type: audio/mpegurl
      sockwrite -n %sw.sockname Connection: Close
      sockwrite -n %sw.sockname $crlf
      sockwrite -n %sw.sockname #EXTM3U
      set %dump $findfile(%sw.dir,$+($remove(%sw.request,playall\,.m3u),*.mp3),0,sockwrite -n %sw.sockname $+(#EXTINF:,$int($calc($sound($1-).length / 1000)),$chr(44),$sound($1-).artist - $sound($1-).title,$chr(32),[mIRC Streamworks Server]) $crlf $replace($1-,%sw.dir,%sw.server,\,/))
      sockclose %sw.sockname
      unset %dump
      halt
    }
    if ($right(%sw.streamfile,4) == .m3u && $exists($replace(%sw.streamfile,.m3u,.mp3)) == $true) {
      if ($sock(stream*,0) > $readini(streamworks,server,maxsingle)) {
        sockwrite -n %sw.sockname ICY 504 Server Full
        sockclose %sw.sockname
        halt
      } 
      set %sw.actualfile $replace(%sw.streamfile,.m3u,.mp3)
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Content-Type: audio/mpegurl
      sockwrite -n %sw.sockname Connection: close
      sockwrite -n %sw.sockname $crlf
      sockwrite -n %sw.sockname #EXTM3U
      sockwrite -n %sw.sockname $+(#EXTINF:,$int($calc($sound(%sw.actualfile).length / 1000)),$chr(44),$sound(%sw.actualfile).artist - $sound(%sw.actualfile).title,$chr(32),[mIRC Streamworks Server])
      sockwrite -n %sw.sockname $replace(%sw.actualfile,%sw.dir,%sw.server)
      sockclose %sw.sockname
      halt
    }
    if ($exists(%sw.streamfile) == $true && $right(%sw.streamfile,4) == .mp3) {
      if ($sock(stream*,0) > $readini(streamworks,server,maxsingle)) {
        sockwrite -n %sw.sockname ICY 504 Server Full
        sockclose %sw.sockname
        halt
      } 
      set %sw.filesize $file(%sw.streamfile).size
      sockmark %sw.sockname $+(%sw.streamfile,$chr(1),$3,$chr(1),%sw.filesize,$chr(1),$2,$chr(1),$4)
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Date: $+($date(ddd),$chr(44)) $date(dd mmm yyyy) $time(hh:mm:ss z) GMT
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Accept-Ranges: bytes
      sockwrite -n %sw.sockname Content-Length: %sw.filesize
      sockwrite -n %sw.sockname Content-Range: $+(0-,$calc(%sw.filesize - 1),/,%sw.filesize)
      sockwrite -n %sw.sockname Content-Type: audio/mpeg
      sockwrite -n %sw.sockname $+(icy-name:,$sound(%sw.streamfile).artist - $sound(%sw.streamfile).title,$chr(32),[mIRC Streamworks Server]) 
      sockwrite -n %sw.sockname $+(icy-br:,$sound(%sw.streamfile).bitrate)
      sockwrite -n %sw.sockname Connection: close
      sockwrite -n %sw.sockname $crlf
      streamit %sw.sockname
      listthestreams
    }
    if ((%sw.request == $null || %sw.request == listen.pls) && $readini(streamworks,server,livemode) == on) {
      if ($sock(livestream*,0) >= $readini(streamworks,server,maxlive)) {
        sockwrite -n %sw.sockname ICY 504 Server Full
        sockclose %sw.sockname
        halt
      } 
      :pickrand
      set %randnum $rand(1,$findfile($readini(streamworks,server,dir),*.mp3,0,$readini(streamworks,server,alldir)))
      set %sw.track $findfile($readini(streamworks,server,dir),*.mp3,%randnum,$readini(streamworks,server,alldir))
      if ($sound(%sw.track).sample != 44100 || Stereo !isin $sound(%sw.track).mode) { goto pickrand }
      if ($readini(streamworks,server,restrict) == on && $sound(%sw.track).bitrate > $readini(streamworks,server,kbps)) { goto pickrand }
      set %size $file(%sw.track).size
      sockmark %sw.sockname $+(%sw.track,$chr(1),1,$chr(1),%size,$chr(1),$2,$chr(1),$4)
      sockwrite -n %sw.sockname HTTP/1.1 200 OK
      sockwrite -n %sw.sockname Server: Cynagen mIRC MP3 StreamWorks v1.9.1
      sockwrite -n %sw.sockname Connection: Keep-Alive
      if (Winamp isin $2 && %sw.request == listen.pls) {
        sockwrite -n %sw.sockname Content-Type: audio/x-scpls
        sockwrite -n %sw.sockname Connection: close
        sockwrite -n %sw.sockname $crlf
        sockwrite -n %sw.sockname [Playlist]
        sockwrite -n %sw.sockname File1= $+ %sw.server
        sockwrite -n %sw.sockname Title1=Live Streaming $iif($readini(streamworks,server,mystream) == on,$+([http://,%sw.server,mystream,])) [mIRC Streamworks Server]
        sockwrite -n %sw.sockname Length1=-1
        sockwrite -n %sw.sockname Numberofentries=1
        sockwrite -n %sw.sockname Version=2
        sockclose %sw.sockname
        halt
      }
      sockwrite -n %sw.sockname Content-Type: audio/mpeg
      sockwrite -n %sw.sockname icy-name: Live Streaming $iif($readini(streamworks,server,mystream) == on,$+([http://,%sw.server,mystream,])) [mIRC Streamworks Server]
      if ($4 == metadata) { sockwrite -n %sw.sockname icy-metaint: 4096 }
      sockwrite -n %sw.sockname $crlf
      sockrename %sw.sockname $+(live,%sw.sockname)
      livestream $+(live,%sw.sockname)
      listthestreams
      halt
    }
    if (($exists(%sw.streamfile) == $false && $remove(%sw.streamfile,%sw.dir) != $null) || $right(%sw.streamfile,4) != .mp3) {
      sockwrite -n %sw.sockname HTTP/1.1 404 NOT FOUND
      sockclose %sw.sockname
    }
  }
  if ($2 == SHOUTcast Directory Tester) {
    sockwrite -n %sw.sockname ICY 200 OK
    sockwrite -n %sw.sockname icy-notice1:<BR>This stream requires <a href="http://www.winamp.com/">Winamp</a><BR>
    sockwrite -n %sw.sockname icy-notice2:mIRC MP3 StreamWorks v1.9.1<BR>
    sockwrite -n %sw.sockname $+(icy-name:,$nick,'s server)
    sockwrite -n %sw.sockname icy-genre:Local Content
    sockwrite -n %sw.sockname icy-url:http:// $+ %sw.server
    sockwrite -n %sw.sockname Content-Type:audio/mpeg
    sockwrite -n %sw.sockname icy-pub:1
    sockwrite -n %sw.sockname icy-br:$iif($readini(streamworks,server,kbps),$readini(streamworks,server,kbps),320)
    sockclose %sw.sockname
    halt
  }
  if (Winamp !isin $2 && Real !isin $2 && Audion !isin $2 && iTunes !isin $2 && Mozilla !isin $2) {
    sockwrite -n %sw.sockname HTTP/1.1 405 METHOD UNALLOWED
    sockwrite -n %sw.sockname $crlf
    sockclose %sw.sockname
  }
}

alias -l whatis {
  if ($isid) {
    if ($prop == init) {
      if (iTunes isin $1 || Winamp3 isin $1) { return advanced }
      if (Real isin $1 || Audion isin $1 || Winamp isin $1) { return normal }
      if ($1 == Mozilla) { return web }
    }
    if ($prop == dist) {
      if (Real isin $1 || Audion isin $1 || iTunes isin $1) { return $push }
      if (Winamp isin $1) { return $pull }
    }
    if ($prop == $null) { 
      if (Winamp isin $1 || Winamp3 isin $1 || Real isin $1 || Audion isin $1 || iTunes isin $1) { return player }
      if (Mozilla isin $1) { return browser }
    }
  }
}

on *:sockwrite:stream*:{
  tokenize 1 $sock($sockname).mark
  if ($whatis($4).dist == $push) { .timer $+ $sockname -h 1 $calc((4 / ($sound($1).bitrate / 32)) * 240) streamit $sockname }
  if ($whatis($4).dist == $pull) { streamit $sockname }
}

on *:sockwrite:livestream*:{
  tokenize 1 $sock($sockname).mark
  if ($5 == $null) {
    if ($whatis($4).dist == $push) { .timer $+ $sockname -h 1 $calc((4 / ($sound($1).bitrate / 32)) * 240) livestream $sockname }
    if ($whatis($4).dist == $pull) { livestream $sockname }
  }
  if ($5 == metadata) {
    if ($whatis($4).dist == $push) { .timer $+ $sockname -h 1 $calc((4 / ($sound($1).bitrate / 32)) * 240) livestream $sockname }
    if ($whatis($4).dist == $pull) { .timer $+ $sockname -m 1 1 livestream $sockname }
  }
}

on *:sockclose:stream*:listthestreams
on *:sockclose:livestream*:listthestreams

alias streamit {
  set %sw.sockname $1
  tokenize 1 $sock(%sw.sockname).mark
  if ($dialog(%sw.sockname).table == streaminfo) {
    did -o %sw.sockname 2 1 Streaming
    did -o %sw.sockname 4 1 %sw.sockname
    did -o %sw.sockname 6 1 $convertbytes($sock(%sw.sockname).sent)
    did -o %sw.sockname 8 1 $convertbytes($sock(%sw.sockname).rcvd)
    did -o %sw.sockname 10 1 $4
    did -o %sw.sockname 12 1 $sock(%sw.sockname).ip
    did -o %sw.sockname 14 1 $nopath($1)
  }
  if ($2 < $3 && $sock(%sw.sockname).sq < 16384) {
    if ($calc($3 - $2) >= 4096) {
      bunset &streamdata
      bread $shortfn($1) $2 4096 &streamdata
      set %inc 4096
    }
    if ($calc($3 - $2) < 4096) {
      bunset &streamdata
      bread $shortfn($1) $2 $calc($3 - $2) &streamdata
      set %inc $calc($3 - $2)
    }
    sockwrite %sw.sockname &streamdata
    sockmark %sw.sockname $+($1,$chr(1),$calc($2 + %inc),$chr(1),$3,$chr(1),$4)
    unset %inc
  }
  if ($2 == $3) {
    if ($dialog(%sw.sockname)) { did -o %sw.sockname 2 1 Disconnected }
    sockclose %sw.sockname
    listthestreams
  }
}

alias livestream {
  :winampmetadata
  if (!$sock($1)) { listthestreams }
  if ($sock($1)) {
    set %sw.sockname $1
    tokenize 1 $sock(%sw.sockname).mark
    if ($dialog(%sw.sockname).table == streaminfo) {
      did -o %sw.sockname 2 1 Live Streaming
      did -o %sw.sockname 4 1 %sw.sockname
      did -o %sw.sockname 6 1 $convertbytes($sock(%sw.sockname).sent)
      did -o %sw.sockname 8 1 $convertbytes($sock(%sw.sockname).rcvd)
      did -o %sw.sockname 10 1 $4
      did -o %sw.sockname 12 1 $sock(%sw.sockname).ip
      did -o %sw.sockname 14 1 $nopath($1)
    }
    if ($2 < $3 && $sock(%sw.sockname).sq <= 12292) {
      if ($calc($3 - $2) >= 4096) {
        bread $shortfn($1) $2 4096 &streamdata
        set %inc 4096
        sockmark %sw.sockname $+($1,$chr(1),$calc($2 + %inc),$chr(1),$3,$chr(1),$4,$chr(1),$5)
      }
      if ($calc($3 - $2) < 4096) {
        bread $shortfn($1) $2 $calc($3 - $2) &streamdata
        set %inc $calc($3 - $2)
        if ($dialog(%sw.sockname)) { did -o %sw.sockname 2 1 Changing tracks }
        :pickrand
        set %randnum $rand(1,$findfile($readini(streamworks,server,dir),*.mp3,0))
        set %sw.track $findfile($readini(streamworks,server,dir),*.mp3,%randnum)
        if (%sw.track == $1 || $sound(%sw.track).sample != 44100 || Stereo !isin $sound(%sw.track).mode) { goto pickrand }
        if ($readini(streamworks,server,restrict) == on && $sound(%sw.track).bitrate > $readini(streamworks,server,kbps)) { goto pickrand }
        set %size $file(%sw.track).size
        set %leadin $calc(4096 - %inc)
        bread $shortfn(%sw.track) 1 %leadin &adddata
        bcopy &streamdata $calc($bvar(&streamdata,0) + 1) &adddata 1 -1
        bunset &adddata
        sockmark %sw.sockname $+(%sw.track,$chr(1),%leadin,$chr(1),%size,$chr(1),$4,$chr(1),$5)
        tokenize 1 $sock(%sw.sockname).mark
      }
      if ($5 == metadata) {
        set %sw.lastsong $var($+(%,sw.,%sw.sockname,lastfile),1).value
        if ($1 != %sw.lastsong) {
          set %meta.data $+(StreamTitle=',$replace($sound($1).artist - $sound($1).title,',`),';)
          set $+(%,sw.,%sw.sockname,lastfile) $1
        }
        if ($1 == %sw.lastsong) { unset %meta.data }
        unset %sw.lastsong
        if (!$sound($1).artist && !$sound($1).title) { set %meta.data $+(StreamTitle=',$replace($remove($nopath($1),.mp3),',`),';) }
        set %meta.len $len(%meta.data)
        if (%meta.len == 0 || %meta.len == $null) {
          bunset &metadata
          bset &metadata 1 0
          goto skipmetadata
        }
        set %meta.byte 1
        set %meta.total $calc(%meta.byte * 16)
        while ($calc(%meta.byte * 16) < $len(%meta.data)) {
          inc %meta.byte
        }
        set %meta.pad $calc((%meta.byte * 16) - $len(%meta.data))
        :metadata
        if ($calc(%meta.byte * 16) > $len(%meta.data) && $sock(%sw.sockname).sq < 12292) {
          bset -t &metadata 1 $+($chr(%meta.byte),%meta.data)
          bset &metadatapad 1 $str($+(0,$chr(32)),%meta.pad)
          bcopy &metadata $calc($bvar(&metadata,0) + 1) &metadatapad 1 -1
          bunset &metadatapad
          unset %meta.*
        }
        if ($bvar(&metadata,0) == $null || $bvar(&metadata,0) == 0) {
          bset &metadata 1 0
          goto metadata
        }
        :skipmetadata
      }
      if ($sock(%sw.sockname).sq < 12292) {
        sockwrite %sw.sockname &streamdata 
        bunset &streamdata
        if ($5 == metadata) { sockwrite %sw.sockname &metadata }
      }
      unset %inc
    }
  }
}

on *:socklisten:servstreamworks: {
  :setname
  inc %sw.id
  if (%sw.id >= 1000) { set %sw.id 1 }
  set %sw.sockname $+(init,%sw.id)
  if ($sock(%sw.sockname)) { goto setname }
  sockaccept %sw.sockname
}

dialog mainlist {
  title "Stream List"
  size -1 -1 100 90
  option dbu
  text "Doubleclick a stream to view properties", 1, 0 1 100 8, center
  list 2, 0 10 100 70, size
  button "REFRESH LIST", 3, 0 80 100 10, default
}

on *:DIALOG:mainlist:INIT:0:listthestreams

on *:DIALOG:mainlist:SCLICK:3:listthestreams

on *:DIALOG:mainlist:DCLICK:2:{
  if ($did(2).seltext) {
    if ($dialog($did(2).seltext) == $null) { dialog -mdv $did(2).seltext streaminfo }
    if ($dialog($did(2).seltext) != $null) { dialog -v $did(2).seltext }
  }
}

alias -l listthestreams {
  if ($dialog(mainlist)) {
    did -r mainlist 2
    set %sw.count.stream 1
    set %sw.count.live 1
    :streams
    if (%sw.count.stream <= $sock(stream*,0)) {
      if ($dialog(mainlist) == mainlist) { did -a mainlist 2 $sock(stream*,%sw.count.stream) }
      inc %sw.count.stream
      goto streams
    }
    :livestreams
    if (%sw.count.live <= $sock(livestream*,0)) {
      if ($dialog(mainlist) == mainlist) { did -a mainlist 2 $sock(livestream*,%sw.count.live) }
      inc %sw.count.live
      goto livestreams
    }
    unset %sw.count.*
  }
  if ($dialog(swcp)) {
    if ($sock(servstreamworks)) { did -c swcp 4 | did -e swcp 5 | did -u swcp 6 | did -b swcp 6 }
    if (!$sock(servstreamworks) && ($sock(stream*,1) || $sock(livestream*,1))) { did -e swcp 5 | did -c swcp 5 | did -u swcp 6 | did -b swcp 6 }
  }
  updatetitle
}

alias convertbytes {
  if ($isid && $1 != $null) {
    unset %convert
    if ($1 >= 0) { set %convert $bytes($1,b).suf }
    if ($1 >= 1024) { set %convert $bytes($1,k).suf }
    if ($1 >= 1048576) { set %convert $bytes($1,m).suf }
    if ($1 >= 1073741824) { set %convert $bytes($1,g).suf }
    if ($1 >= 1099511627776) { set %convert $bytes($1,t).suf }
    return %convert
  }
}

dialog streaminfo {
  title "Stream info"
  size -1 -1 120 100
  option dbu
  text "Status:", 1, 10 1 50 8, center
  text "Status", 2, 60 1 50 8, center
  text "Stream Name:", 3, 10 11 50 8, center
  text "Name", 4, 60 11 50 8, center
  text "Transmitted:", 5, 10 21 50 8, center
  text "0", 6, 60 21 50 8, center
  text "Received:", 7, 10 31 50 8, center
  text "0", 8, 60 31 50 8, center
  text "Agent:", 9, 10 41 50 8, center
  text "Agentname", 10, 60 41 50 8, center
  text "IP Address:", 11, 10 51 50 8, center
  text "255.255.255.255", 12, 60 51 50 8, center
  text "File Currently Streaming:", 13, 10 61 100 8, center
  text "Filename", 14, 10 71 100 8, center
  button "Disconnect", 15, 10 80 50 10
  button "OK", 16, 60 80 50 10, default ok
}

on *:DIALOG:stream*:sclick:15:{
  did -o $dname 2 1 Disconnected
  sockclose $dname
  listthestreams
}

on *:DIALOG:livestream*:sclick:15:{
  did -o $dname 2 1 Disconnected
  sockclose $dname
  listthestreams
}

menu menubar,status,@Streamworks {
  Streamworks
  .Control Panel:$iif($dialog(swcp),dialog -v swcp,dialog -md swcp swcp)
  .Power
  ..$iif($sock(servstreamworks) != $null,$style(1)) ON:{
    if ($sock(servstreamworks) == $null) {
      scanartists
      if ($readini(streamworks,server,bindip) != $null) { socklisten -d $readini(streamworks,server,bindip) servstreamworks $iif($readini(streamworks,server,port),$readini(streamworks,server,port),4000) }
      if ($readini(streamworks,server,bindip) == $null) { socklisten servstreamworks $iif($readini(streamworks,server,port),$readini(streamworks,server,port),4000) }
    }
    if ($readini(streamworks,server,autolist) == on) { shoutcastyp }
    if (!$readini(streamworks,server,alldir)) { writeini streamworks server alldir 100 }
    if (!$readini(streamworks,server,livemode)) { writeini streamworks server livemode on }
  }
  ..$iif($sock(servstreamworks),$iif($sock(stream*) || $sock(livestream*),STANDBY,OFF),$iif($sock(stream*) || $sock(livestream*),$style(1) STANDBY,$style(1) OFF)) $+ :{ sockclose servstreamworks | if ($readini(streamworks,server,autolist) == on) { rmvscyp } }
  .Settings
  ..Port $+([,$iif($readini(streamworks,server,port),$readini(streamworks,server,port),$+(Default,$chr(58),$chr(32),4000)),]) $+ :{
    set %port $?="What port would you like Streamworks to run on? (Blank for default)"
    if (%port != $null) { writeini streamworks server port %port }
    if (%port == $null) { remini streamworks server port }
    unset %port
  }
  ..IP $iif($readini(streamworks,server,bindip),$+([,$readini(streamworks,server,bindip),]),$+([Detected,$chr(58),$chr(32),$swip,])) $+ :{
    set %ip $?="What IP would you like Streamworks to run on? (Blank for auto-detect)"
    if (%ip != $null) { writeini streamworks server bindip %ip }
    if (%ip == $null) { remini streamworks server bindip }
    unset %ip
  }
  ..Directory $+([,$iif($readini(streamworks,server,dir),$readini(streamworks,server,dir),$+(Default,$chr(58),$chr(32),C,$chr(58),\)),]) $+ :writeini streamworks server dir $sdir(C:\,Please select a folder for Streamworks to stream)
  ..$iif($readini(streamworks,server,mystream) == on,$style(1)) MyStream Pages:$iif($readini(streamworks,server,mystream) == on,writeini -n streamworks server mystream off,writeini -n streamworks server mystream on)
  ..Screen Logging
  ...$iif(%scrlog,$style(1)) Basic:$iif(!%scrlog,set %scrlog on)
  ...$iif(%scrlogall,$style(1)) Advanced:$iif(%scrlogall == on,unset %scrlogall,set %scrlogall on)
  ...$iif(!%scrlog,$style(1)) Off:$iif(%scrlog,unset %scrlog*)
  .View Streams:dialog -md mainlist mainlist
}

alias -l swip {
  if ($isid) {
    if ($readini(streamworks,server,bindip)) { return $readini(streamworks,server,bindip) }
    if ($sock(servstreamworks).ip) { return $sock(servstreamworks).ip }
    if ($ip) { return $ip }
    return 127.0.0.1
  }
}

on *:DIALOG:swcp:INIT:0:{
  did -o swcp 11 1 $swip 
  did -o swcp 10 1 4000
  did -o swcp 12 1 C:\
  did -c swcp 6,14,23,24
  did -o swcp 18,20 1 3
  did -b swcp 5
  did -o swcp 27 1 $readini(streamworks,server,kbps)
  did -o swcp 45 1 Offline
  if (!$readini(streamworks,server,alldir)) { writeini streamworks server alldir 100 }
  if (!$readini(streamworks,server,livemode)) { writeini streamworks server livemode on }
  if ($readini(streamworks,server,bindip)) { did -o swcp 11 1 $readini(streamworks,server,bindip) }
  if ($readini(streamworks,server,port)) { did -o swcp 9 1 $readini(streamworks,server,port) }
  if ($readini(streamworks,server,dir)) { did -o swcp 12 1 $readini(streamworks,server,dir) }
  if ($sock(servstreamworks)) { did -c swcp 4 | did -e swcp 5 | did -u swcp 6 | did -b swcp 6 }
  if (!$sock(servstreamworks) && ($sock(stream*,1) || $sock(livestream*,1))) { did -e swcp 5 | did -c swcp 5 | did -u swcp 6 | did -b swcp 6 }
  if ($readini(streamworks,server,livemode) == off) { did -u swcp 23 }
  if ($readini(streamworks,server,metadata) == off) { did -u swcp 24 }
  if ($readini(streamworks,server,mystream) == on) { did -c swcp 25 }
  if ($readini(streamworks,server,restrict) == on) { did -c swcp 26 | did -e swcp 27 }
  if ($readini(streamworks,server,maxlive)) { did -o swcp 18 1 $readini(streamworks,server,maxlive) }
  if ($readini(streamworks,server,maxsingle)) { did -o swcp 20 1 $readini(streamworks,server,maxsingle) }
  if ($readini(streamworks,server,alldir) >= 2) { did -u swcp 14 | did -c swcp 15 }
  if ($readini(streamworks,server,autolist) == on) { did -c swcp 46 }
  did -o swcp 49 1 $iif($readini(streamworks,server,scname),$replace($readini(streamworks,server,scname),$chr(32),$+($chr(37),20)),$+($iif($nick,$+($nick,'s,$chr(37),20,StreamWorks),StreamWorks),$chr(37),20,Server))
  did -o swcp 51 1 $iif($readini(streamworks,server,scgenre),$replace($readini(streamworks,server,scgenre),$chr(32),$+($chr(37),20)),$+(Local,$chr(37),20,MP3s))
  did -o swcp 53 1 $iif($readini(streamworks,server,scurl),$readini(streamworks,server,scurl),$+(http://,$swip,:,%scyp.port,/))
  if ($timer(tchscyp)) {
    did -o swcp 45 1 Online
    did -o swcp 47 1 Rem from list now
  }
  did -o swcp 22 1 $calc($did(18).text + $did(20).text)
}

on *:DIALOG:swcp:EDIT:*:{
  if ($did == 18 && $did(18).text) {
    if ($did(18).text !isnum) { did -o swcp 18 1 $readini(streamworks,server,maxlive) }
    writeini streamworks server maxlive $did(18).text
    did -o swcp 22 1 $calc($did(18).text + $did(18).text)
  }
  if ($did == 20 && $did(20).text) {
    if ($did(20).text !isnum) { did -o swcp 20 1 $readini(streamworks,server,maxsingle) }
    writeini streamworks server maxsingle $did(20).text
    did -o swcp 22 1 $calc($did(18).text + $did(20).text)
  }
  if ($did == 27 && $did(27).text) {
    if ($did(27).text !isnum) { did -o swcp 27 1 $readini(streamworks,server,kbps) }
    writeini streamworks server kbps $did(27).text
  }
  if ($did == 49) {
    if ($did(49).text == $null) { remini streamworks server scname }
    if ($did(49).text == $null) { writeini streamworks server scname $did(49).text }
  }
  if ($did == 51) {
    if ($did(51).text == $null) { remini streamworks server scgenre }
    if ($did(51).text == $null) { writeini streamworks server scgenre $did(51).text }
  }
  if ($did == 53) {
    if ($did(53).text == $null) { remini streamworks server scurl }
    if ($did(53).text == $null) { writeini streamworks server scurl $did(53).text }
  }
}

on *:DIALOG:swcp:SCLICK:*:{
  if ($did == 4 && !$sock(servstreamworks) && $did($did).enabled == $true) {
    scanartists
    if ($readini(streamworks,server,bindip) != $null) { socklisten -d $readini(streamworks,server,bindip) servstreamworks $iif($readini(streamworks,server,port),$readini(streamworks,server,port),4000) }
    if ($readini(streamworks,server,bindip) == $null) { socklisten servstreamworks $iif($readini(streamworks,server,port),$readini(streamworks,server,port),4000) }
    if ($readini(streamworks,server,autolist) == on) { shoutcastyp }
    did -b swcp 6
    did -e swcp 5
  }
  if ($did == 5 && $sock(servstreamworks) && $did($did).enabled == $true) {
    sockclose servstreamworks
    if ($readini(streamworks,server,autolist) == on) { rmvscyp }
  }
  if ($did == 6 && $sock(servstreamworks) && $did($did).enabled == $true) {
    halt
  }
  if ($did == 14 && $did(14).state == 1) {
    writeini streamworks server alldir 100
  }
  if ($did == 15 && $did(15).state == 1) {
    writeini streamworks server alldir 1
  }
  if ($did == 23) {
    if ($did(23).state == 0) { writeini streamworks server livemode off }
    if ($did(23).state == 1) { writeini streamworks server livemode on }
  }
  if ($did == 24) {
    if ($did(24).state == 0) { writeini streamworks server metadata off }
    if ($did(24).state == 1) { writeini streamworks server metadata on }
  }
  if ($did == 25) {
    if ($did(25).state == 0) { writeini streamworks server mystream off }
    if ($did(25).state == 1) { writeini streamworks server mystream on }
  }
  if ($did == 26) {
    if ($did(26).state == 0) {
      writeini streamworks server restrict off
      writeini streamworks server kbps $iif($did(27).text,$did(27).text,128)
      if ($did(27).enabled) { did -b swcp 27 }
    }
    if ($did(26).state == 1) {
      writeini streamworks server restrict on
      writeini streamworks server kbps $iif($did(27).text,$did(27).text,128)
      if (!$did(27).enabled) { did -e swcp 27 )
      }
    }
  }
  if ($did == 30) {
    writeini banip.ini bans $$?="Input the IP address to be banned here." banned
    listbans
  }
  if ($did == 31 && $did(29).seltext) {
    remini banip.ini bans $did(29).seltext
    listbans
  }
  if ($did == 40) { 
    set %port $?="What port would you like Streamworks to run on? (Blank for default)"
    if (%port != $null) { writeini streamworks server port %port }
    if (%port == $null) { remini streamworks server port }
    unset %port
    did -o swcp 10 1 $iif($readini(streamworks,server,port),$readini(streamworks,server,port),4000)
    dialog -v swcp
  }
  if ($did == 41) {
    set %ip $?="What IP would you like Streamworks to run on? (Blank for auto-detect)"
    if (%ip != $null) { writeini streamworks server bindip %ip }
    if (%ip == $null) { remini streamworks server bindip }
    unset %ip
    did -o swcp 11 1 $swip
    dialog -v swcp
  }
  if ($did == 46) {
    if ($did(46).state == 1) { writeini streamworks server autolist on }
    if ($did(46).state == 0) { writeini streamworks server autolist off }
  }
  if ($did == 47) {
    if ($timer(tchscyp) >= 1) { did -o swcp 47 1 Add to list now | rmvscyp | halt }
    if ($timer(tchscyp) == $null) { did -o swcp 47 1 Rem from list now | shoutcastyp | halt }
  }
  if ($did == 42) {
    writeini streamworks server dir $sdir(C:\,Please select a folder for Streamworks to stream)
    did -o swcp 12 1 $readini(streamworks,server,dir)
    dialog -v swcp
  }
}

alias -l listbans {
  did -r swcp 29
  set %banned 1
  while (%banned <= $ini(banip.ini,bans,0)) {
    if ($readini(banip.ini,bans,$ini(banip.ini,bans,%banned)) == banned && $dialog(swcp)) {
      did -a swcp 29 $ini(banip.ini,bans,%banned)
    }
    inc %banned
  }
  unset %banned
}

dialog swcp {
  title "StreamWorks Control Panel"
  size -1 -1 200 70
  option dbu
  tab "Main", 1, 10 0 179 57
  radio "On", 4, 20 20 30 10, tab 1
  radio "Standby", 5, 20 30 30 10, tab 1
  radio "Off", 6, 20 40 30 10, tab 1
  text "Server Port:", 7, 60 21 30 8, tab 1
  text "Server IP:", 8, 60 31 30 8, tab 1
  text "Server Dir:", 9, 60 41 30 8, tab 1
  edit "", 10, 90 20 50 10, tab 1 center read
  edit "", 11, 90 30 50 10, tab 1 center read
  edit "", 12, 90 40 50 10, tab 1 center read
  tab "Main Ext", 2
  radio "Use All In Dir", 14, 20 20 50 10, tab 2
  radio "Use Only Dir", 15, 20 30 50 10, tab 2
  text "Max Live Streams:", 17, 90 21 50 8, tab 2 right
  edit "", 18, 140 20 20 10, tab 2 center
  text "Max Single Streams:", 19, 90 31 50 8, tab 2 right
  edit "", 20, 140 30 20 10, tab 2 center
  text "Max Total Streams:", 21, 90 41 50 8, tab 2 right
  edit "", 22, 140 40 20 10, tab 2 read center
  tab "Live Mode", 3
  check "Enable Live Mode", 23, 20 20 70 10, tab 3
  check "Enable MetaData", 24, 20 30 70 10, tab 3
  check "Enable /MySteam Pages", 25, 100 20 70 10, tab 3
  check "Restrict Song kbps", 26, 100 30 60 10, tab 3
  edit "128", 27, 160 30 20 10, disable tab 3 center
  tab "Banned IPs", 28
  list 29, 20 20 70 30, tab 28 sort size vsbar
  button "+", 30, 90 20 10 15, tab 28
  button "-", 31, 90 35 10 15, tab 28
  text "Use this to ban abusive IPs. Or to block out the RIAA...", 32, 110 28 70 14, tab 28
  button "Edit Setting", 40, 140 20 45 10, tab 1
  button "Edit Setting", 41, 140 30 45 10, tab 1
  button "Edit Setting", 42, 140 40 45 10, tab 1
  tab "SHOUTcast", 43
  text "Listed:", 44, 20 21 20 10, tab 43
  text "", 45, 40 21 30 10, tab 43 center
  check "List on Power On", 46, 20 30 50 10, tab 43
  button "Add to list now", 47, 20 40 50 10, tab 43
  text "Server Name:", 48, 90 21 35 10, tab 43
  edit "", 49, 125 20 55 10, tab 43
  text "Server Genre:", 50, 90 31 35 10, tab 43
  edit "", 51, 125 30 55 10, tab 43
  text "Server URL:", 52, 90 41 35 10, tab 43
  edit "", 53, 125 40 55 10, tab 43
}

on *:UNLOAD: {
  sockclose *stream*
  unset %meta.*
  unset %sw.*
  unset %*.dump
  rmvscyp
}

on *:START: { updatetitle }

alias -l updatetitle { titlebar MP3 StreamWorks v1.9.1 - Live: $+([,$sock(livestream*,0),/,$readini(streamworks,server,maxlive),]) - Single: $+([,$sock(stream*,0),/,$readini(streamworks,server,maxsingle),]) }
